<script setup lang="ts">
import { ref, onMounted } from 'vue'
import { type MessageBoxOptions } from '../components/MessageBox'
import { type WaitBoxOptions } from '../components/WaitBox'
import { type RestErrorBoxOptions } from '../components/RestErrorBox'
import MessageBox from '../components/MessageBox.vue'
import WaitBox from '../components/WaitBox.vue'
import MenuBox from '../components/MenuBox.vue'
import RestErrorBox from '../components/RestErrorBox.vue'

// states
const messageBox = ref(<InstanceType<typeof MessageBox> | null>null)
const waitBox = ref(<InstanceType<typeof WaitBox> | null>null)
const menuBox = ref(<InstanceType<typeof MenuBox> | null>null)
const restErrorBox = ref(<InstanceType<typeof RestErrorBox> | null>null)

onMounted(() => {
	messageBox.value?.setDefaults(<MessageBoxOptions>{
		barrierBackground: '#666c',
		titleBackground: '#336',
		titleColor: '#eef',
		//rightIcon: true,
	})

	waitBox.value?.setDefaults(<WaitBoxOptions>{
		barrierBackground: '#666c',
		edgeBackground: '#333',
		iconColor: '#3c3',
		//rightIcon: true,
	})

	//restErrorBox.value?.setDefaults(<RestErrorBoxOptions>{})
})

// ----------------------------------------------------------------------

// exposed API
defineExpose({

	// -- MessageBox --------------------------------------------------------

	messageBoxIsOpen: function (): boolean {
		return messageBox.value?.isOpen() ?? false
	},

	messageBoxOpen: function (options: MessageBoxOptions): boolean {
		return messageBox.value?.open(options) ?? false
	},

	messageBoxInfo: function (content: string, callback?: (result: boolean) => void): boolean {
		return messageBox.value?.info(content, callback) ?? false
	},

	messageBoxWarning: function (content: string, callback?: (result: boolean) => void): boolean {
		return messageBox.value?.warning(content, callback) ?? false
	},

	messageBoxError: function (content: string, callback?: (result: boolean) => void): boolean {
		return messageBox.value?.error(content, callback) ?? false
	},

	messageBoxQuestion: function (content: string, callback?: (result: boolean) => void): boolean {
		return messageBox.value?.question(content, callback) ?? false
	},

	// -- WaitBox -----------------------------------------------------------

	waitBoxIsOpen: function (): boolean {
		return waitBox.value?.isOpen() ?? false
	},

	waitBoxOpen: function (o?: WaitBoxOptions): boolean {
		return waitBox.value?.open(o) ?? false
	},

	waitBoxClose: function (): void {
		return waitBox.value?.close()
	},

	// -- MenuBox -----------------------------------------------------------

	menuBoxIsOpen: function (): boolean {
		return menuBox.value?.isOpen() ?? false
	},

	menuBoxOpen: function (): boolean {
		return menuBox.value?.open() ?? false
	},

	menuBoxClose: function (): void {
		return menuBox.value?.close()
	},

	// -- RestErrorBox ------------------------------------------------------

	restErrorBoxIsOpen: function (): boolean {
		return restErrorBox.value?.isOpen() ?? false
	},

	restErrorBoxOpen: function (o: RestErrorBoxOptions): boolean {
		return restErrorBox.value?.open(o) ?? false
	},

})
</script>


<template>
	<div>
		<MessageBox ref="messageBox" />
		<WaitBox ref="waitBox" />
		<MenuBox ref="menuBox" />
		<RestErrorBox ref="restErrorBox" />
	</div>
</template>
